"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jsonRulesEngineSimplified = require("json-rules-engine-simplified");

var _jsonRulesEngineSimplified2 = _interopRequireDefault(_jsonRulesEngineSimplified);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EngineFactory = function () {
  function EngineFactory() {
    _classCallCheck(this, EngineFactory);
  }

  _createClass(EngineFactory, [{
    key: "createEngine",
    value: function createEngine(rules, schema) {
      this.rules = rules;
      this.schema = schema;
      this.engine = new _jsonRulesEngineSimplified2.default(rules, schema);
    }
  }, {
    key: "getEngine",
    value: function getEngine(rules, schema) {
      if (!(0, _deepEqual2.default)(this.rules, rules) || !(0, _deepEqual2.default)(this.schema, schema)) {
        this.createEngine(rules, schema);
      }
      return this.engine;
    }
  }]);

  return EngineFactory;
}();

exports.default = new EngineFactory();